/*
 * This file contains the implementation of the
 * Linux re-IPL support
 *
 * (C) Copyright IBM Corp. 2005
 *
 * Author(s): Volker Sameske (sameske@de.ibm.com)
 *
 */

#include <linux/kernel.h>

/*
 * re-IPL the system using the last used IPL parameters
 */
void reipl_diag(void)
{
	static u32 rc1, rc2;

        asm volatile (
#ifdef __s390x__
		"   xgr  %%r4,%%r4\n"
		"   xgr  %%r5,%%r5\n"
#else
		"   xr   %%r4,%%r4\n"
		"   xr   %%r5,%%r5\n"
#endif
                "   diag %%r4,%2,0x308\n"
                "0:\n"
		"   lr %0,%%r4\n"
		"   lr %1,%%r5\n"
                ".section __ex_table,\"a\"\n"
#ifdef __s390x__
                "   .align 8\n"
                "   .quad 0b, 0b\n"
#else
                "   .align 4\n"
                "   .long 0b, 0b\n"
#endif
                ".previous\n"
                : "=d" (rc1), "=d" (rc2) : "d" (3) : "cc", "4", "5" );
}
