/* taskdelays.h - Header file to be used by CKRM
 *
 * Copyright  © Hubertus Franke, IBM Corp. 2003-2007
 *            © Shailabh Nagar,  IBM Corp. 2003-2007
 *            © Chandra Seetharaman, IBM Corp. 2003-2007
 *
 * Provides data structure for delay statistics
 *
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2.1 of the GNU Lesser General Public License
 * as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it would be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

#ifndef _LINUX_TASKDELAYS_H
#define _LINUX_TASKDELAYS_H

#include <linux/config.h>
#include <linux/types.h>

struct task_delay_info {
#if defined CONFIG_DELAY_ACCT 
	/* delay statistics in usecs */
	uint64_t waitcpu_total;
	uint64_t runcpu_total;
	uint64_t iowait_total;
	uint64_t mem_iowait_total;
	uint32_t runs;
	uint32_t num_iowaits;
	uint32_t num_memwaits;
	uint64_t splpar_total;
#endif				
};

#endif				// _LINUX_TASKDELAYS_H
